(function () {
	'use strict';

	globalThis.undefined = undefined;
	var target = globalThis.target;
	var primordials = globalThis.primordials;
	var symbol = primordials.symbol,
	  number = primordials.number,
	  string = primordials.string,
	  object = primordials.object,
	  buffer = primordials.buffer,
	  func = primordials.function,
	  json = primordials.json,
	  map = primordials.map,
	  regex = primordials.regex,
	  setGlobalPrototypes = primordials.setGlobalPrototypes,
	  compile = primordials.compile,
	  now = primordials.now,
	  next = primordials.next;
	  primordials.schedule;

	function _callSuper(self, constr, args) {
	  return func.construct(object.getPrototype(constr), func.target(1), args || []);
	}

	function _inherits(t, e) {
	  if (e == null) {
	    object.setPrototype(t.prototype, undefined);
	  } else {
	    object.setPrototype(t.prototype, e.prototype);
	    object.setPrototype(t, e);
	  }
	}

	function _defineProperties(target, arr) {
	  if (!arr) return;
	  for (var i = 0; i < arr.length; i++) {
	    var desc = arr[i];
	    var res;
	    var w, e, c;
	    c = desc.configurable;
	    if (c == null) c = true;
	    e = desc.enumerable;
	    if (e == null) e = false;
	    if ("value" in desc) {
	      w = desc.writable;
	      if (w == null) w = true;
	      if (desc.writable == null) res = object.defineField(target, desc.key, {
	        w: !!w,
	        e: !!e,
	        c: !!c,
	        v: desc.value
	      });
	    } else {
	      res = object.defineProperty(target, desc.key, {
	        e: !!e,
	        c: !!c,
	        g: desc.get,
	        s: desc.set
	      });
	    }
	    if (!res) throw "Couldn't set property";
	  }
	}
	function _createClass(clazz, instance, nonInstance) {
	  _defineProperties(clazz.prototype, instance);
	  _defineProperties(clazz, nonInstance);
	  return clazz;
	}

	function _defineProperty(obj, key, val) {
	  if (obj == null) return;
	  object.defineField(obj, key, {
	    c: true,
	    e: true,
	    w: true,
	    v: val
	  });
	  return obj;
	}

	var valueKey = symbol.makeSymbol("Primitive.value");
	var symbols;
	(function (_symbols) {
	  _symbols.asyncIterator = symbol.makeSymbol("Symbol.asyncIterator");
	  _symbols.iterator = symbol.makeSymbol("Symbol.iterator");
	  _symbols.match = symbol.makeSymbol("Symbol.match");
	  _symbols.matchAll = symbol.makeSymbol("Symbol.matchAll");
	  _symbols.replace = symbol.makeSymbol("Symbol.replace");
	  _symbols.search = symbol.makeSymbol("Symbol.search");
	  _symbols.split = symbol.makeSymbol("Symbol.split");
	  _symbols.toStringTag = symbol.makeSymbol("Symbol.toStringTag");
	  _symbols.isConcatSpreadable = symbol.makeSymbol("Symbol.isConcatSpreadable");
	})(symbols || (symbols = {}));
	function unwrapThis(self, type, constr, name) {
	  var arg = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : "this";
	  var defaultVal = arguments.length > 5 ? arguments[5] : undefined;
	  if (typeof self === type) return self;
	  if (self instanceof constr && valueKey in self) self = self[valueKey];
	  if (typeof self === type) return self;
	  if (defaultVal !== undefined) return defaultVal;
	  throw new TypeError(name + " requires that '" + arg + "' be a " + constr.name);
	}
	function wrapI(i, length) {
	  if (i < 0) return i + length | 0;else return i | 0;
	}
	function limitI(i, max) {
	  i |= 0;
	  if (i < 0) return 0;else if (i > max) return max;else return i;
	}
	function parseReplacer(replacer, groupN) {
	  var parts = [];
	  var lastI = 0;
	  var lastSlice = 0;
	  var _loop = function () {
	      var i = string.indexOf(replacer, "$", lastI);
	      if (i < 0 || i + 1 >= replacer.length) return 0; // break
	      lastI = i + 1;
	      switch (replacer[i + 1]) {
	        case "$":
	          parts[parts.length] = string.substring(replacer, lastSlice, i);
	          parts[parts.length] = "$";
	          lastSlice = i + 2;
	          return 1; // continue
	        case "&":
	          parts[parts.length] = string.substring(replacer, lastSlice, i);
	          parts[parts.length] = function (_ref) {
	            var groups = _ref.groups;
	            return groups[0];
	          };
	          lastSlice = i + 2;
	          return 1; // continue
	        case "`":
	          parts[parts.length] = string.substring(replacer, lastSlice, i);
	          parts[parts.length] = function (_ref2) {
	            var prev = _ref2.prev;
	            return prev();
	          };
	          lastSlice = i + 2;
	          return 1; // continue
	        case "'":
	          parts[parts.length] = string.substring(replacer, lastSlice, i);
	          parts[parts.length] = function (_ref3) {
	            var next = _ref3.next;
	            return next();
	          };
	          lastSlice = i + 2;
	          return 1; // continue
	      }
	      var groupI = 0;
	      var hasGroup = false;
	      var consumedN = 1;
	      while (i + consumedN < replacer.length) {
	        var code = string.toCharCode(replacer[i + consumedN]);
	        if (code >= 48 && code <= 57) {
	          var newGroupI = groupI * 10 + code - 48;
	          if (newGroupI < 1 || newGroupI >= groupN) break;
	          groupI = newGroupI;
	          hasGroup = true;
	        }
	        consumedN++;
	      }
	      if (hasGroup) {
	        parts[parts.length] = string.substring(replacer, lastSlice, i);
	        parts[parts.length] = function (_ref4) {
	          var groups = _ref4.groups;
	          return groups[groupI];
	        };
	        lastSlice = i + consumedN;
	        return 1; // continue
	      }
	    },
	    _ret;
	  while (true) {
	    _ret = _loop();
	    if (_ret === 0) break;
	    if (_ret === 1) continue;
	  }
	  if (lastSlice === 0) return [replacer];else parts[parts.length] = string.substring(replacer, lastSlice, replacer.length);
	  return parts;
	}
	function executeReplacer(text, match, literal, prevEnd, nextStart) {
	  var res = [];
	  for (var i = 0; i < literal.length; i++) {
	    var curr = literal[i];
	    if (typeof curr === "function") res[i] = curr({
	      groups: match.matches,
	      next: function () {
	        return string.substring(text, prevEnd !== null && prevEnd !== undefined ? prevEnd : 0, match.start);
	      },
	      prev: function () {
	        return string.substring(text, match.end, nextStart !== null && nextStart !== undefined ? nextStart : 0);
	      }
	    });else res[i] = curr;
	  }
	  return string.stringBuild(res);
	}
	function applyReplaces(text, ranges, replace, groupN) {
	  if (ranges.length === 0) return text;
	  var res = [];
	  var offset = 0;
	  if (groupN !== false && typeof replace === "string") {
	    if (groupN == null) {
	      for (var i = 0; i < ranges.length; i++) {
	        var prevEnd = i - 1 >= 0 ? ranges[i - 1].end : undefined;
	        var nextStart = i + 1 < ranges.length ? ranges[i + 1].start : undefined;
	        var range = ranges[i];
	        res[res.length] = string.substring(text, offset, range.start);
	        res[res.length] = executeReplacer(text, range, parseReplacer(replace, range.matches.length), prevEnd, nextStart);
	        offset = range.end;
	      }
	      res[res.length] = string.substring(text, offset, text.length);
	    } else {
	      var literal = parseReplacer(replace, groupN);
	      for (var _i = 0; _i < ranges.length; _i++) {
	        var _prevEnd = _i - 1 >= 0 ? ranges[_i - 1].end : undefined;
	        var _nextStart = _i + 1 < ranges.length ? ranges[_i + 1].start : undefined;
	        var _range = ranges[_i];
	        res[res.length] = string.substring(text, offset, _range.start);
	        res[res.length] = executeReplacer(text, _range, literal, _prevEnd, _nextStart);
	        offset = _range.end;
	      }
	      res[res.length] = string.substring(text, offset, text.length);
	    }
	    return string.stringBuild(res);
	  }
	  if (typeof replace === "string") {
	    for (var _i2 = 0; _i2 < ranges.length; _i2++) {
	      var _range2 = ranges[_i2];
	      res[res.length] = string.substring(text, offset, _range2.start);
	      res[res.length] = replace;
	      offset = _range2.end;
	    }
	    res[res.length] = string.substring(text, offset, text.length);
	  } else {
	    for (var _i3 = 0; _i3 < ranges.length; _i3++) {
	      var _range3 = ranges[_i3];
	      var args = _range3.matches;
	      args[args.length] = _range3.start;
	      args[args.length] = text;
	      args[args.length] = _range3.groups;
	      res[res.length] = string.substring(text, offset, _range3.start);
	      res[res.length] = func.invoke(replace, undefined, args);
	      offset = _range3.end;
	    }
	    res[res.length] = string.substring(text, offset, text.length);
	  }
	  return string.stringBuild(res);
	}
	function applySplits(text, limit, next) {
	  var lastEnd = 0;
	  var lastEmpty = true;
	  var offset = 0;
	  var res = [];
	  while (true) {
	    if (limit != null && limit >= 0 && res.length >= limit) break;
	    var curr = next(offset);
	    if (curr == null) {
	      if (!lastEmpty || !res.length) res[res.length] = string.substring(text, lastEnd, text.length);
	      break;
	    }
	    var start = curr.start,
	      end = curr.end;
	    var empty = start === end;
	    if (offset > 0 || !empty) res[res.length] = string.substring(text, lastEnd, start);
	    lastEnd = end;
	    offset = empty ? end + 1 : end;
	    lastEmpty = empty;
	  }
	  return res;
	}

	var _symbols$split, _symbols$replace;
	var regexKey = symbol.makeSymbol("RegExp.impl");
	_symbols$split = symbols.split;
	_symbols$replace = symbols.replace;
	var RegExp = /*#__PURE__*/function (_symbols$split2, _symbols$replace2) {
	  function RegExp(source) {
	    var flags = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "";
	    _defineProperty(this, regexKey, undefined);
	    _defineProperty(this, "source", undefined);
	    _defineProperty(this, "flags", undefined);
	    _defineProperty(this, "lastIndex", 0);
	    _defineProperty(this, "indices", undefined);
	    _defineProperty(this, "global", undefined);
	    _defineProperty(this, "ignoreCase", undefined);
	    _defineProperty(this, "multiline", undefined);
	    _defineProperty(this, "dotall", undefined);
	    _defineProperty(this, "unicode", undefined);
	    _defineProperty(this, "unicodeSets", undefined);
	    _defineProperty(this, "sticky", undefined);
	    if (func.invokeType(arguments, this) === "call") return new RegExp(source, flags);
	    source = this.source = String$1(typeof source === "object" && "source" in source ? source.source : source);
	    flags = String$1(flags);
	    var indices = false;
	    var global = false;
	    var ignoreCase = false;
	    var multiline = false;
	    var dotall = false;
	    var unicode = false;
	    var unicodeSets = false;
	    var sticky = false;
	    for (var i = 0; i < flags.length; i++) {
	      switch (flags[i]) {
	        case "d":
	          indices = true;
	          break;
	        case "g":
	          global = true;
	          break;
	        case "i":
	          ignoreCase = true;
	          break;
	        case "m":
	          multiline = true;
	          break;
	        case "s":
	          dotall = true;
	          break;
	        case "u":
	          unicode = true;
	          break;
	        case "v":
	          unicodeSets = true;
	          break;
	        case "y":
	          sticky = true;
	          break;
	      }
	    }
	    flags = "";
	    if (indices) flags += "d";
	    if (global) flags += "g";
	    if (ignoreCase) flags += "i";
	    if (multiline) flags += "m";
	    if (dotall) flags += "s";
	    if (unicode) flags += "u";
	    if (unicodeSets) flags += "v";
	    if (sticky) flags += "y";
	    this.flags = flags;
	    this.indices = indices;
	    this.global = global;
	    this.ignoreCase = ignoreCase;
	    this.multiline = multiline;
	    this.dotall = dotall;
	    this.unicode = unicode;
	    this.unicodeSets = unicodeSets;
	    this.sticky = sticky;
	    this[regexKey] = new regex(source, multiline, ignoreCase, dotall, unicode, unicodeSets);
	  }
	  return _createClass(RegExp, [{
	    key: "exec",
	    value: function exec(target) {
	      var useLast = this.global || this.sticky;
	      var start = useLast ? this.lastIndex : 0;
	      var match = this[regexKey].exec(target, start, this.indices);
	      if (match != null && !(this.sticky && match.matches.index !== start)) {
	        if (useLast) this.lastIndex = match.end;
	        return match.matches;
	      }
	      if (useLast) this.lastIndex = 0;
	      return null;
	    }
	  }, {
	    key: "test",
	    value: function test(target) {
	      return this.exec(target) != null;
	    }
	  }, {
	    key: _symbols$split2,
	    value: function (target, limit) {
	      var _this = this;
	      return applySplits(target, limit, function (offset) {
	        var val = _this[regexKey].exec(target, offset, false);
	        if (val == null) return undefined;
	        return {
	          start: val.matches.index,
	          end: val.end
	        };
	      });
	    }
	  }, {
	    key: _symbols$replace2,
	    value: function (target, replacer) {
	      var matches = [];
	      var regex = this[regexKey];
	      if (this.global) {
	        var offset = 0;
	        while (true) {
	          var match = regex.exec(target, offset, false);
	          if (match == null) break;
	          var start = match.matches.index;
	          var end = match.end;
	          var arr = [];
	          for (var i = 0; i < match.matches.length; i++) {
	            arr[i] = match.matches[i];
	          }
	          matches[matches.length] = {
	            start: match.matches.index,
	            end: match.end,
	            matches: arr
	          };
	          if (start === end) offset = start + 1;else offset = end;
	        }
	        return applyReplaces(target, matches, replacer, regex.groupCount() + 1);
	      } else {
	        var _match = this.exec(target);
	        if (_match != null) matches[0] = {
	          start: _match.index,
	          end: _match.index + _match[0].length,
	          matches: _match
	        };
	      }
	      return applyReplaces(target, matches, replacer, regex.groupCount() + 1);
	    }
	  }]);
	}(_symbols$split, _symbols$replace);

	var trimStartRegex = new regex("^\\s+", false, false, false, false, false);
	var trimEndRegex = new regex("\\s+$", false, false, false, false, false);
	var String$1 = function (_symbols$iterator) {
	  _symbols$iterator = symbols.iterator;
	  var String = /*#__PURE__*/function (_symbols$iterator2) {
	    function String(value) {
	      _defineProperty(this, valueKey, undefined);
	      if (func.invokeType(arguments, this) === "call") {
	        if (arguments.length === 0) return "";else if (typeof value === "symbol") return value.toString();else return value + "";
	      }
	      this[valueKey] = String(value);
	    }
	    return _createClass(String, [{
	      key: "at",
	      value: function at(index) {
	        throw "Not implemented :/";
	      }
	    }, {
	      key: "toString",
	      value: function toString() {
	        return unwrapThis(this, "string", String, "String.prototype.toString");
	      }
	    }, {
	      key: "valueOf",
	      value: function valueOf() {
	        return unwrapThis(this, "string", String, "String.prototype.valueOf");
	      }
	    }, {
	      key: "includes",
	      value: function includes(search) {
	        var offset = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
	        var self = unwrapThis(this, "string", String, "String.prototype.indexOf");
	        return string.indexOf(self, String(search), +offset, false) >= 0;
	      }
	    }, {
	      key: "startsWith",
	      value: function startsWith(search) {
	        var self = unwrapThis(this, "string", String, "String.prototype.indexOf");
	        if (self.length < search.length) return false;
	        return string.substring(self, 0, search.length) === search;
	      }
	    }, {
	      key: "endsWith",
	      value: function endsWith(search) {
	        var self = unwrapThis(this, "string", String, "String.prototype.indexOf");
	        if (self.length < search.length) return false;
	        return string.substring(self, self.length - search.length, self.length) === search;
	      }
	    }, {
	      key: "indexOf",
	      value: function indexOf(search) {
	        var offset = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
	        var self = unwrapThis(this, "string", String, "String.prototype.indexOf");
	        offset = +offset;
	        return string.indexOf(self, search, offset, false);
	      }
	    }, {
	      key: "lastIndexOf",
	      value: function lastIndexOf(search) {
	        var offset = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
	        var self = unwrapThis(this, "string", String, "String.prototype.lastIndexOf");
	        offset = +offset;
	        return string.indexOf(self, search, offset, true);
	      }
	    }, {
	      key: "trim",
	      value: function trim() {
	        var self = unwrapThis(this, "string", String, "String.prototype.trim");
	        var start = trimStartRegex.exec(self, 0, false);
	        var end = trimEndRegex.exec(self, 0, false);
	        var startI = start == null ? 0 : start.end;
	        var endI = end == null ? self.length : end.matches.index;
	        return string.substring(self, startI, endI);
	      }
	    }, {
	      key: "trimStart",
	      value: function trimStart() {
	        var self = unwrapThis(this, "string", String, "String.prototype.trim");
	        var start = trimStartRegex.exec(self, 0, false);
	        var startI = start == null ? 0 : start.end;
	        return string.substring(self, startI, self.length);
	      }
	    }, {
	      key: "trimEnd",
	      value: function trimEnd() {
	        var self = unwrapThis(this, "string", String, "String.prototype.trim");
	        var end = trimEndRegex.exec(self, 0, false);
	        var endI = end == null ? self.length : end.matches.index;
	        return string.substring(self, 0, endI);
	      }
	    }, {
	      key: "trimLeft",
	      value: function trimLeft() {
	        return func.invoke(String.prototype.trimStart, this, []);
	      }
	    }, {
	      key: "trimRight",
	      value: function trimRight() {
	        return func.invoke(String.prototype.trimEnd, this, []);
	      }
	    }, {
	      key: "charAt",
	      value: function charAt(i) {
	        var self = unwrapThis(this, "string", String, "String.prototype.charAt");
	        return self[i];
	      }
	    }, {
	      key: "charCodeAt",
	      value: function charCodeAt(i) {
	        var self = unwrapThis(this, "string", String, "String.prototype.charCodeAt");
	        return self[i] ? string.toCharCode(self[i]) : number.NaN;
	      }
	    }, {
	      key: "codePointAt",
	      value: function codePointAt(i) {
	        var self = unwrapThis(this, "string", String, "String.prototype.charCodeAt");
	        return i >= 0 && i < self.length ? string.toCodePoint(self, i) : number.NaN;
	      }
	    }, {
	      key: "split",
	      value: function split(val, limit) {
	        var self = unwrapThis(this, "string", String, "String.prototype.split");
	        if (val === undefined) return [self];
	        if (val !== null && typeof val === "object" && symbols.split in val) {
	          return val[symbols.split](self, limit);
	        }
	        val = String(val);
	        return applySplits(self, limit, function (offset) {
	          var start = string.indexOf(self, val, offset, false);
	          if (start < 0) return undefined;else return {
	            start: start,
	            end: start + val.length
	          };
	        });
	      }
	    }, {
	      key: "replace",
	      value: function replace(val, replacer) {
	        var self = unwrapThis(this, "string", String, "String.prototype.replace");
	        if (val !== null && typeof val === "object" && symbols.replace in val) {
	          return val[symbols.replace](self, replacer);
	        } else val = String(val);
	        var i = string.indexOf(self, val, 0);
	        return applyReplaces(self, [{
	          start: i,
	          end: i + val.length,
	          matches: [val]
	        }], replacer, false);
	      }
	    }, {
	      key: "replaceAll",
	      value: function replaceAll(val, replacer) {
	        var self = unwrapThis(this, "string", String, "String.prototype.replaceAll");
	        if (val !== null && typeof val === "object" && symbols.replace in val) {
	          if (val instanceof RegExp && !val.global) throw new TypeError$1("replaceAll must be called with a global RegExp");
	          return val[symbols.replace](self, replacer);
	        } else val = String(val);
	        var offset = 0;
	        var matches = [];
	        var add = val.length === 0 ? 1 : val.length;
	        while (true) {
	          var i = string.indexOf(self, val, offset);
	          if (i < 0) break;
	          matches[matches.length] = {
	            start: i,
	            end: i + val.length,
	            matches: [val]
	          };
	          if (val.length === 0) offset = i + add;
	        }
	        return applyReplaces(self, matches, replacer, false);
	      }
	    }, {
	      key: "repeat",
	      value: function repeat(n) {
	        var self = unwrapThis(this, "string", String, "String.prototype.replaceAll");
	        var res = [];
	        for (var i = 0; i < n; i++) {
	          res[i] = self;
	        }
	        return string.stringBuild(res);
	      }
	    }, {
	      key: "slice",
	      value: function slice() {
	        var start = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
	        var end = arguments.length > 1 ? arguments[1] : undefined;
	        var self = unwrapThis(this, "string", String, "String.prototype.slice");
	        if (end === undefined) end = self.length;
	        start = limitI(wrapI(start, self.length), self.length);
	        end = limitI(wrapI(end, self.length), self.length);
	        if (end <= start) return "";
	        return string.substring(self, start, end);
	      }
	    }, {
	      key: "substring",
	      value: function substring() {
	        var start = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
	        var end = arguments.length > 1 ? arguments[1] : undefined;
	        var self = unwrapThis(this, "string", String, "String.prototype.substring");
	        if (end === undefined) end = self.length;
	        start = limitI(start, self.length);
	        end = limitI(end, self.length);
	        if (end <= start) return "";
	        return string.substring(self, start, end);
	      }
	    }, {
	      key: "substr",
	      value: function substr() {
	        var start = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
	        var count = arguments.length > 1 ? arguments[1] : undefined;
	        var self = unwrapThis(this, "string", String, "String.prototype.substr");
	        count = self.length - start;
	        start = limitI(start, self.length);
	        count = limitI(count, self.length - start);
	        if (count <= 0) return "";
	        return string.substring(self, start, count + start);
	      }
	    }, {
	      key: "concat",
	      value: function concat() {
	        var self = unwrapThis(this, "string", String, "String.prototype.concat");
	        var parts = [self];
	        for (var i = 0; i < arguments.length; i++) {
	          parts[i + 1] = String(arguments[i]);
	        }
	        return string.stringBuild(parts);
	      }
	    }, {
	      key: "toLowerCase",
	      value: function toLowerCase() {
	        var self = unwrapThis(this, "string", String, "String.prototype.toLowerCase");
	        return string.lower(self);
	      }
	    }, {
	      key: "toUpperCase",
	      value: function toUpperCase() {
	        var self = unwrapThis(this, "string", String, "String.prototype.toLowerCase");
	        return string.upper(self);
	      }
	    }, {
	      key: "match",
	      value: function match(regex) {
	        var self = unwrapThis(this, "string", String, "String.prototype.match");
	        if (!(regex instanceof RegExp)) throw new TypeError$1("Regexp expected for String.prototype.match");
	        if (regex.global) {
	          var matches = null;
	          while (true) {
	            var _match = regex.exec(self);
	            if (_match == null) break;
	            matches || (matches = []);
	            matches[matches.length] = _match[0];
	          }
	          return matches;
	        } else return regex.exec(self);
	      }
	    }, {
	      key: _symbols$iterator2,
	      value: function () {
	        var i = 0;
	        var arr = unwrapThis(this, "string", String, "String.prototype[Symbol.iterator]");
	        return _defineProperty({
	          next: function () {
	            if (arr == null) return {
	              done: true,
	              value: undefined
	            };
	            if (i > arr.length) {
	              arr = undefined;
	              return {
	                done: true,
	                value: undefined
	              };
	            } else {
	              var val = arr[i++];
	              if (i >= arr.length) arr = undefined;
	              return {
	                done: false,
	                value: val
	              };
	            }
	          }
	        }, symbols.iterator, function () {
	          return this;
	        });
	      }
	    }], [{
	      key: "fromCharCode",
	      value: function fromCharCode() {
	        var res = [];
	        res[arguments.length] = "";
	        for (var i = 0; i < arguments.length; i++) {
	          res[i] = string.fromCharCode(+arguments[i]);
	        }
	        return string.stringBuild(res);
	      }
	    }, {
	      key: "fromCodePoint",
	      value: function fromCodePoint() {
	        var res = [];
	        res[arguments.length] = "";
	        for (var i = 0; i < arguments.length; i++) {
	          res[i] = string.fromCodePoint(+arguments[i]);
	        }
	        return string.stringBuild(res);
	      }
	    }]);
	  }(_symbols$iterator);
	  func.setCallable(String, true);
	  func.setConstructable(String, true);
	  return String;
	}();

	var Error$1 = /*#__PURE__*/function () {
	  function Error() {
	    var msg = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "";
	    if (func.invokeType(arguments, this) === "call") return new Error(msg);
	    this.message = String$1(msg);
	  }
	  return _createClass(Error, [{
	    key: "toString",
	    value: function toString() {
	      var res = this.name || "Error";
	      var msg = this.message;
	      if (msg) res += ": " + msg;
	      return res;
	    }
	  }]);
	}();
	object.defineField(Error$1.prototype, "name", {
	  c: true,
	  e: false,
	  w: true,
	  v: "Error"
	});
	object.defineField(Error$1.prototype, "message", {
	  c: true,
	  e: false,
	  w: true,
	  v: ""
	});
	func.setCallable(Error$1, true);
	func.setConstructable(Error$1, true);
	var SyntaxError = /*#__PURE__*/function (_Error) {
	  function SyntaxError() {
	    return _callSuper(this, SyntaxError, arguments);
	  }
	  _inherits(SyntaxError, _Error);
	  return _createClass(SyntaxError);
	}(Error$1);
	object.defineField(SyntaxError.prototype, "name", {
	  c: true,
	  e: false,
	  w: true,
	  v: "SyntaxError"
	});
	func.setCallable(SyntaxError, true);
	func.setConstructable(SyntaxError, true);
	var TypeError$1 = /*#__PURE__*/function (_Error2) {
	  function TypeError() {
	    return _callSuper(this, TypeError, arguments);
	  }
	  _inherits(TypeError, _Error2);
	  return _createClass(TypeError);
	}(Error$1);
	object.defineField(TypeError$1.prototype, "name", {
	  c: true,
	  e: false,
	  w: true,
	  v: "TypeError"
	});
	func.setCallable(TypeError$1, true);
	func.setConstructable(TypeError$1, true);
	var RangeError = /*#__PURE__*/function (_Error3) {
	  function RangeError() {
	    return _callSuper(this, RangeError, arguments);
	  }
	  _inherits(RangeError, _Error3);
	  return _createClass(RangeError);
	}(Error$1);
	object.defineField(RangeError.prototype, "name", {
	  c: true,
	  e: false,
	  w: true,
	  v: "RangeError"
	});
	func.setCallable(RangeError, true);
	func.setConstructable(RangeError, true);

	var Boolean = function () {
	  var Boolean = /*#__PURE__*/function () {
	    function Boolean(value) {
	      _defineProperty(this, valueKey, undefined);
	      if (func.invokeType(arguments, this) === "call") {
	        if (arguments.length === 0) return false;else return !!value;
	      }
	      this[valueKey] = Boolean(value);
	    }
	    return _createClass(Boolean, [{
	      key: "toString",
	      value: function toString() {
	        return "" + unwrapThis(this, "boolean", Boolean, "Boolean.prototype.toString");
	      }
	    }, {
	      key: "valueOf",
	      value: function valueOf() {
	        return unwrapThis(this, "boolean", Boolean, "Boolean.prototype.valueOf");
	      }
	    }]);
	  }();
	  func.setCallable(Boolean, true);
	  func.setConstructable(Boolean, true);
	  return Boolean;
	}();

	var Function = function () {
	  var Function = /*#__PURE__*/function () {
	    function Function() {
	      var parts = ["(function anonymous("];
	      for (var i = 0; i < arguments.length - 1; i++) {
	        if (i > 0) parts[parts.length] = ",";
	        parts[parts.length] = arguments[i];
	      }
	      parts[parts.length] = "){\n";
	      parts[parts.length] = String$1(arguments[arguments.length - 1]);
	      parts[parts.length] = "\n})";
	      var res = compile(string.stringBuild(parts))();
	      return res;
	    }
	    return _createClass(Function, [{
	      key: "toString",
	      value: function toString() {
	        if (this.name !== "") return "function " + this.name + "(...) { ... }";else return "function (...) { ... }";
	      }
	    }, {
	      key: "valueOf",
	      value: function valueOf() {
	        return this;
	      }
	    }, {
	      key: "apply",
	      value: function apply(self, args) {
	        return func.invoke(this, self, args);
	      }
	    }, {
	      key: "call",
	      value: function call(self) {
	        var args = [];
	        for (var i = arguments.length - 1; i >= 1; i--) args[i - 1] = arguments[i];
	        return func.invoke(this, self, args);
	      }
	    }, {
	      key: "bind",
	      value: function bind(self) {
	        var cb = this;
	        if (arguments.length === 0) return function () {
	          return func.invoke(cb, this, arguments);
	        };
	        if (arguments.length <= 1) return function () {
	          return func.invoke(cb, self, arguments);
	        };
	        var base = [];
	        var offset = arguments.length - 1;
	        base.length = offset;
	        for (var i = 0; i < offset; i++) base[i] = arguments[i + 1];
	        return function () {
	          for (var _i = 0; _i < arguments.length; _i++) {
	            base[offset + _i] = arguments[_i];
	          }
	          return func.invoke(cb, self, base);
	        };
	      }
	    }], [{
	      key: "compile",
	      value: function compile$1() {
	        var src = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "";
	        var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
	          _ref$globals = _ref.globals,
	          globals = _ref$globals === undefined ? [] : _ref$globals,
	          _ref$wrap = _ref.wrap,
	          wrap = _ref$wrap === undefined ? false : _ref$wrap;
	        var parts = [];
	        if (wrap) parts[parts.length] = "return (function() {\n";
	        if (globals.length > 0) {
	          parts[parts.length] = "let {";
	          for (var i = 0; i < globals.length; i++) {
	            if (i > 0) parts[parts.length] = ",";
	            parts[parts.length] = globals[i];
	          }
	          parts[parts.length] = "} = arguments[0];";
	        }
	        parts[parts.length] = src;
	        if (wrap) parts[parts.length] = "\n})(arguments[0])";
	        var res = compile(string.stringBuild(parts));
	        return res;
	      }
	    }]);
	  }();
	  func.setCallable(Function, true);
	  func.setConstructable(Function, true);
	  return Function;
	}();

	var Number$1 = function () {
	  var Number = /*#__PURE__*/function () {
	    function Number(value) {
	      _defineProperty(this, valueKey, undefined);
	      if (func.invokeType(arguments, this) === "call") {
	        if (arguments.length === 0) return 0;else return +value;
	      }
	      this[valueKey] = Number(value);
	    }
	    return _createClass(Number, [{
	      key: "toString",
	      value: function toString() {
	        return "" + unwrapThis(this, "number", Number, "Number.prototype.toString");
	      }
	    }, {
	      key: "valueOf",
	      value: function valueOf() {
	        return unwrapThis(this, "number", Number, "Number.prototype.toString");
	      }
	    }], [{
	      key: "isFinite",
	      value: function isFinite(value) {
	        value = unwrapThis(value, "number", Number, "Number.isFinite", "value");
	        if (value === undefined || value !== value) return false;
	        if (value === number.Infinity || value === -number.Infinity) return false;
	        return true;
	      }
	    }, {
	      key: "isInteger",
	      value: function isInteger(value) {
	        value = unwrapThis(value, "number", Number, "Number.isInteger", "value");
	        if (value === undefined) return false;
	        return number.parseInt(value) === value;
	      }
	    }, {
	      key: "isNaN",
	      value: function isNaN(value) {
	        return number.isNaN(value);
	      }
	    }, {
	      key: "isSafeInteger",
	      value: function isSafeInteger(value) {
	        value = unwrapThis(value, "number", Number, "Number.isSafeInteger", "value");
	        if (value === undefined || number.parseInt(value) !== value) return false;
	        return value >= -9007199254740991 && value <= 9007199254740991;
	      }
	    }, {
	      key: "parseFloat",
	      value: function parseFloat(value) {
	        if (typeof value === "number") return value;else return number.parseFloat(value + "");
	      }
	    }, {
	      key: "parseInt",
	      value: function parseInt(value) {
	        var radix = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 10;
	        radix = +radix;
	        if (number.isNaN(radix)) radix = 10;
	        if (typeof value === "number") return number.parseInt(value, radix);else return number.parseInt(value + "", radix);
	      }
	    }]);
	  }();
	  object.defineField(Number, "EPSILON", {
	    c: false,
	    e: false,
	    w: false,
	    v: 2.220446049250313e-16
	  });
	  object.defineField(Number, "MIN_SAFE_INTEGER", {
	    c: false,
	    e: false,
	    w: false,
	    v: -9007199254740991
	  });
	  object.defineField(Number, "MAX_SAFE_INTEGER", {
	    c: false,
	    e: false,
	    w: false,
	    v: 9007199254740991
	  });
	  object.defineField(Number, "POSITIVE_INFINITY", {
	    c: false,
	    e: false,
	    w: false,
	    v: +number.Infinity
	  });
	  object.defineField(Number, "NEGATIVE_INFINITY", {
	    c: false,
	    e: false,
	    w: false,
	    v: -number.Infinity
	  });
	  object.defineField(Number, "NaN", {
	    c: false,
	    e: false,
	    w: false,
	    v: number.NaN
	  });
	  object.defineField(Number, "MAX_VALUE", {
	    c: false,
	    e: false,
	    w: false,
	    v: 1.7976931348623157e+308
	  });
	  object.defineField(Number, "MIN_VALUE", {
	    c: false,
	    e: false,
	    w: false,
	    v: 5e-324
	  });
	  func.setCallable(Number, true);
	  func.setConstructable(Number, true);
	  return Number;
	}();

	var Symbol = function () {
	  var Symbol = /*#__PURE__*/function () {
	    function Symbol() {
	      var name = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "";
	      _defineProperty(this, valueKey, undefined);
	      return symbol.makeSymbol(name + "");
	    }
	    return _createClass(Symbol, [{
	      key: "description",
	      get: function () {
	        return symbol.getSymbolDescription(unwrapThis(this, "symbol", Symbol, "Symbol.prototype.description"));
	      }
	    }, {
	      key: "toString",
	      value: function toString() {
	        return "Symbol(" + unwrapThis(this, "symbol", Symbol, "Symbol.prototype.toString").description + ")";
	      }
	    }, {
	      key: "valueOf",
	      value: function valueOf() {
	        return unwrapThis(this, "symbol", Symbol, "Symbol.prototype.valueOf");
	      }
	    }], [{
	      key: "for",
	      value: function _for(name) {
	        return symbol.getSymbol(name + "");
	      }
	    }]);
	  }();
	  func.setCallable(Symbol, true);
	  func.setConstructable(Symbol, false);
	  object.defineField(Symbol, "asyncIterator", {
	    c: false,
	    e: false,
	    w: false,
	    v: symbols.asyncIterator
	  });
	  object.defineField(Symbol, "iterator", {
	    c: false,
	    e: false,
	    w: false,
	    v: symbols.iterator
	  });
	  object.defineField(Symbol, "match", {
	    c: false,
	    e: false,
	    w: false,
	    v: symbols.match
	  });
	  object.defineField(Symbol, "matchAll", {
	    c: false,
	    e: false,
	    w: false,
	    v: symbols.matchAll
	  });
	  object.defineField(Symbol, "replace", {
	    c: false,
	    e: false,
	    w: false,
	    v: symbols.replace
	  });
	  object.defineField(Symbol, "search", {
	    c: false,
	    e: false,
	    w: false,
	    v: symbols.search
	  });
	  object.defineField(Symbol, "split", {
	    c: false,
	    e: false,
	    w: false,
	    v: symbols.split
	  });
	  object.defineField(Symbol, "toStringTag", {
	    c: false,
	    e: false,
	    w: false,
	    v: symbols.toStringTag
	  });
	  object.defineField(Symbol, "isConcatSpreadable", {
	    c: false,
	    e: false,
	    w: false,
	    v: symbols.isConcatSpreadable
	  });
	  return Symbol;
	}();

	var Object$1 = function () {
	  var Object = /*#__PURE__*/function () {
	    function Object(value) {
	      if (typeof value === 'object' && value !== null) return value;
	      if (typeof value === 'string') return new String$1(value);
	      if (typeof value === 'number') return new Number$1(value);
	      if (typeof value === 'boolean') return new Boolean(value);
	      if (typeof value === 'symbol') {
	        var res = {};
	        object.setPrototype(res, Symbol.prototype);
	        res[valueKey] = value;
	        return res;
	      }
	      return {};
	    }
	    return _createClass(Object, [{
	      key: "toString",
	      value: function toString() {
	        if (this === undefined) return "[object Undefined]";else if (this === null) return "[object Null]";else if (typeof this === "object") {
	          if (symbols.toStringTag in this) return "[object " + this[symbols.toStringTag] + "]";else if (object.isArray(this)) return "[object Array]";else return "[object Object]";
	        } else if (typeof this === "number" || this instanceof Number$1) return "[object Number]";else if (typeof this === "symbol" || this instanceof Symbol) return "[object Symbol]";else if (typeof this === "string" || this instanceof String$1) return "[object String]";else if (typeof this === "boolean" || this instanceof Boolean) return "[object Boolean]";else if (typeof this === "function") return "[object Function]";
	      }
	    }, {
	      key: "valueOf",
	      value: function valueOf() {
	        return this;
	      }
	    }, {
	      key: "hasOwnProperty",
	      value: function hasOwnProperty(key) {
	        return object.getOwnMember(this, key) != null;
	      }
	    }, {
	      key: "__proto__",
	      get: function () {
	        return object.getPrototype(this);
	      },
	      set: function (val) {
	        object.setPrototype(this, val);
	      }
	    }], [{
	      key: "getOwnPropertyDescriptor",
	      value: function getOwnPropertyDescriptor(obj, key) {
	        return object.getOwnMember(obj, key);
	      }
	    }, {
	      key: "getOwnPropertyNames",
	      value: function getOwnPropertyNames(obj) {
	        return object.getOwnMembers(obj, false);
	      }
	    }, {
	      key: "getOwnPropertySymbols",
	      value: function getOwnPropertySymbols(obj) {
	        return object.getOwnSymbolMembers(obj, false);
	      }
	    }, {
	      key: "defineProperty",
	      value: function defineProperty(obj, key, desc) {
	        if (obj === null || typeof obj !== "function" && typeof obj !== "object") {
	          throw new TypeError$1("Object.defineProperty called on non-object");
	        }
	        if (desc === null || typeof desc !== "function" && typeof desc !== "object") {
	          throw new TypeError$1("Property description must be an object: " + desc);
	        }
	        var res = {};
	        if ("get" in desc || "set" in desc) {
	          if ("get" in desc) {
	            var get = desc.get;
	            if (get !== undefined && typeof get !== "function") throw new TypeError$1("Getter must be a function: " + get);
	            res.g = get;
	          }
	          if ("set" in desc) {
	            var set = desc.set;
	            if (set !== undefined && typeof set !== "function") throw new TypeError$1("Setter must be a function: " + set);
	            res.s = set;
	          }
	          if ("enumerable" in desc) res.e = !!desc.enumerable;
	          if ("configurable" in desc) res.e = !!desc.configurable;
	          if (!object.defineProperty(obj, key, res)) throw new TypeError$1("Cannot redefine property: " + String$1(key));
	        } else {
	          if ("enumerable" in desc) res.e = !!desc.enumerable;
	          if ("configurable" in desc) res.e = !!desc.configurable;
	          if ("writable" in desc) res.w = !!desc.writable;
	          if ("value" in desc) res.v = desc.value;
	          if (!object.defineField(obj, key, res)) throw new TypeError$1("Cannot redefine property: " + String$1(key));
	        }
	        return obj;
	      }
	    }, {
	      key: "defineProperties",
	      value: function defineProperties(obj, desc) {
	        var keys = object.getOwnMembers(desc, true);
	        var symbols = object.getOwnSymbolMembers(desc, true);
	        for (var i = 0; i < keys.length; i++) {
	          Object.defineProperty(obj, keys[i], desc[keys[i]]);
	        }
	        for (var _i = 0; _i < symbols.length; _i++) {
	          Object.defineProperty(obj, symbols[_i], desc[symbols[_i]]);
	        }
	        return obj;
	      }
	    }, {
	      key: "create",
	      value: function create(proto, desc) {
	        var res = object.setPrototype({}, proto);
	        if (desc != null) this.defineProperties(res, desc);
	        return res;
	      }
	    }, {
	      key: "assign",
	      value: function assign(target) {
	        for (var i = 1; i < arguments.length; i++) {
	          var obj = arguments[i];
	          var keys = object.getOwnMembers(obj, false);
	          var _symbols = object.getOwnSymbolMembers(obj, false);
	          for (var j = 0; j < keys.length; j++) {
	            target[keys[j]] = obj[keys[j]];
	          }
	          for (var _j = 0; _j < _symbols.length; _j++) {
	            target[_symbols[_j]] = obj[_symbols[_j]];
	          }
	        }
	        return target;
	      }
	    }, {
	      key: "setPrototypeOf",
	      value: function setPrototypeOf(obj, proto) {
	        object.setPrototype(obj, proto);
	      }
	    }, {
	      key: "getPrototypeOf",
	      value: function getPrototypeOf(obj) {
	        return object.getPrototype(obj) || null;
	      }
	    }, {
	      key: "keys",
	      value: function keys(obj) {
	        var res = [];
	        var keys = object.getOwnMembers(obj, true);
	        var symbols = object.getOwnSymbolMembers(obj, true);
	        for (var i = 0; i < keys.length; i++) {
	          res[res.length] = keys[i];
	        }
	        for (var _i2 = 0; _i2 < symbols.length; _i2++) {
	          res[res.length] = symbols[_i2];
	        }
	        return res;
	      }
	    }, {
	      key: "values",
	      value: function values(obj) {
	        var res = [];
	        var keys = object.getOwnMembers(obj, true);
	        var symbols = object.getOwnSymbolMembers(obj, true);
	        for (var i = 0; i < keys.length; i++) {
	          res[res.length] = obj[keys[i]];
	        }
	        for (var _i3 = 0; _i3 < symbols.length; _i3++) {
	          res[res.length] = obj[symbols[_i3]];
	        }
	        return res;
	      }
	    }, {
	      key: "entries",
	      value: function entries(obj) {
	        var res = [];
	        var keys = object.getOwnMembers(obj, true);
	        var symbols = object.getOwnSymbolMembers(obj, true);
	        for (var i = 0; i < keys.length; i++) {
	          res[res.length] = [keys[i], obj[keys[i]]];
	        }
	        for (var _i4 = 0; _i4 < symbols.length; _i4++) {
	          res[res.length] = [symbols[_i4], obj[symbols[_i4]]];
	        }
	        return res;
	      }
	    }, {
	      key: "preventExtensions",
	      value: function preventExtensions(obj) {
	        object.preventExt(obj);
	        return obj;
	      }
	    }, {
	      key: "seal",
	      value: function seal(obj) {
	        object.seal(obj);
	        return obj;
	      }
	    }, {
	      key: "freeze",
	      value: function freeze(obj) {
	        object.freeze(obj);
	        return obj;
	      }
	    }]);
	  }();
	  object.defineProperty(Object.prototype, "__proto__", {
	    e: false
	  });
	  object.setPrototype(Object.prototype, undefined);
	  func.setCallable(Object, true);
	  func.setConstructable(Object, true);
	  return Object;
	}();

	var Array = function () {
	  var Array = /*#__PURE__*/function (_symbols$iterator) {
	    function Array(len) {
	      if (arguments.length === 1 && typeof len === "number") {
	        var res = [];
	        res.length = len;
	        return res;
	      } else {
	        var _res = [];
	        _res.length = arguments.length;
	        for (var i = 0; i < arguments.length; i++) {
	          _res[i] = arguments[i];
	        }
	        return _res;
	      }
	    }
	    return _createClass(Array, [{
	      key: "forEach",
	      value: function forEach(cb, self) {
	        for (var i = 0; i < this.length; i++) {
	          if (i in this) func.invoke(cb, self, [this[i], i, this]);
	        }
	      }
	    }, {
	      key: "join",
	      value: function join() {
	        var delim = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : ",";
	        delim = String$1(delim);
	        var parts = [];
	        if (delim) {
	          for (var i = 0; i < this.length; i++) {
	            if (i) parts[parts.length] = delim;
	            parts[parts.length] = i in this ? String$1(this[i]) : "";
	          }
	        } else {
	          for (var _i = 0; _i < this.length; _i++) {
	            parts[_i] = _i in this ? String$1(this[_i]) : "";
	          }
	        }
	        return string.stringBuild(parts);
	      }
	    }, {
	      key: "push",
	      value: function push() {
	        var start = this.length;
	        for (var i = arguments.length - 1; i >= 0; i--) {
	          this[start + i] = arguments[i];
	        }
	        return arguments.length;
	      }
	    }, {
	      key: "pop",
	      value: function pop() {
	        if (this.length === 0) return undefined;else {
	          var res = this[this.length - 1];
	          this.length--;
	          return res;
	        }
	      }
	    }, {
	      key: "unshift",
	      value: function unshift() {
	        for (var i = this.length + arguments.length - 1; i >= arguments.length; i--) {
	          this[i] = this[i - arguments.length];
	        }
	        for (var _i2 = 0; _i2 < arguments.length; _i2++) {
	          this[_i2] = arguments[_i2];
	        }
	        return arguments.length;
	      }
	    }, {
	      key: "shift",
	      value: function shift() {
	        if (this.length === 0) return undefined;
	        var tmp = this[0];
	        for (var i = 1; i < this.length; i++) {
	          this[i - 1] = this[i];
	        }
	        this.length--;
	        return tmp;
	      }
	    }, {
	      key: "concat",
	      value: function concat() {
	        var res = [];
	        function add(arr) {
	          if (Array.isArray(arr) || arr != null && typeof arr === "object" && symbols.isConcatSpreadable in arr) {
	            var start = res.length;
	            res.length += arr.length;
	            for (var i = 0; i < res.length; i++) {
	              if (i in arr) res[start + i] = arr[i];
	            }
	          } else res[res.length] = arr;
	        }
	        add(this);
	        for (var i = 0; i < arguments.length; i++) {
	          add(arguments[i]);
	        }
	        return res;
	      }
	    }, {
	      key: "slice",
	      value: function slice() {
	        var start = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
	        var end = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.length;
	        start = wrapI(start, this.length);
	        end = wrapI(end, this.length);
	        if (end <= start) return [];
	        var res = [];
	        res.length = end - start;
	        for (var i = 0; i < end - start; i++) {
	          res[i] = this[start + i];
	        }
	        return res;
	      }
	    }, {
	      key: "splice",
	      value: function splice() {
	        var start = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
	        var count = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.length - start;
	        var vals = [];
	        for (var i = 0; i < arguments.length - 2; i++) vals[i] = arguments[i + 2];
	        start = limitI(wrapI(start, this.length), this.length);
	        count = limitI(wrapI(count, this.length), this.length - start);
	        var res = [];
	        var change = vals.length - count;
	        for (var _i3 = start; _i3 < start + count; _i3++) {
	          res[_i3 - start] = this[_i3];
	        }
	        if (change < 0) {
	          for (var _i4 = start - change; _i4 < this.length; _i4++) {
	            this[_i4 + change] = this[_i4];
	          }
	          this.length = this.length + change;
	        } else {
	          for (var _i5 = this.length - 1; _i5 >= start - change; _i5--) {
	            this[_i5 + change] = this[_i5];
	          }
	        }
	        for (var _i6 = 0; _i6 < vals.length; _i6++) {
	          this[_i6 + start] = vals[_i6];
	        }
	        return res;
	      }
	    }, {
	      key: "map",
	      value: function map(cb, self) {
	        var res = [];
	        res.length = this.length;
	        for (var i = 0; i < this.length; i++) {
	          if (i in this) res[i] = func.invoke(cb, self, [this[i], i, this]);
	        }
	        return res;
	      }
	    }, {
	      key: "filter",
	      value: function filter(cb, self) {
	        var res = [];
	        for (var i = 0; i < this.length; i++) {
	          if (i in this && func.invoke(cb, self, [this[i], i, this])) res[res.length] = this[i];
	        }
	        return res;
	      }
	    }, {
	      key: "reduce",
	      value: function reduce(cb, initial) {
	        var i = 0;
	        if (arguments.length <= 1) initial = this[i++];
	        for (; i < this.length; i++) {
	          initial = cb(initial, this[i], i, this);
	        }
	        return initial;
	      }
	    }, {
	      key: "some",
	      value: function some(cb, self) {
	        for (var i = 0; i < this.length; i++) {
	          if (i in this && func.invoke(cb, self, [this[i], i, this])) return true;
	        }
	        return false;
	      }
	    }, {
	      key: "every",
	      value: function every(cb, self) {
	        for (var i = 0; i < this.length; i++) {
	          if (i in this && !func.invoke(cb, self, [this[i], i, this])) return false;
	        }
	        return true;
	      }
	    }, {
	      key: "find",
	      value: function find(cb, self) {
	        for (var i = 0; i < this.length; i++) {
	          if (i in this && func.invoke(cb, self, [this[i], i, this])) return this[i];
	        }
	        return undefined;
	      }
	    }, {
	      key: "indexOf",
	      value: function indexOf(val) {
	        var start = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
	        start |= 0;
	        if (start < 0) start = 0;
	        for (var i = start; i < this.length; i++) {
	          if (i in this && this[i] === val) return i;
	        }
	        return -1;
	      }
	    }, {
	      key: "lastIndexOf",
	      value: function lastIndexOf(val) {
	        var start = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
	        start |= 0;
	        if (start < 0) start = 0;
	        for (var i = this.length - 1; i >= start; i--) {
	          if (i in this && this[i] === val) return i;
	        }
	        return -1;
	      }
	    }, {
	      key: "includes",
	      value: function includes(val) {
	        for (var i = 0; i < this.length; i++) {
	          if (i in this && this[i] === val) return true;
	        }
	        return false;
	      }
	    }, {
	      key: "sort",
	      value: function sort(cb) {
	        cb || (cb = function (a, b) {
	          if (String$1(a) < String$1(b)) return -1;
	          if (String$1(a) === String$1(b)) return 0;
	          return 1;
	        });
	        return object.sort(this, cb);
	      }
	    }, {
	      key: "reverse",
	      value: function reverse() {
	        var mid = this.length >> 1;
	        var end = this.length - 1;
	        for (var i = 0; i < mid; i++) {
	          var tmp = this[i];
	          this[i] = this[end - i];
	          this[end - i] = tmp;
	        }
	        return this;
	      }
	    }, {
	      key: _symbols$iterator,
	      value: function () {
	        var i = 0;
	        var arr = func.invoke(Array.prototype.slice, this, []);
	        return _defineProperty({
	          next: function () {
	            if (arr == null) return {
	              done: true,
	              value: undefined
	            };
	            if (i >= arr.length) {
	              arr = undefined;
	              return {
	                done: true,
	                value: undefined
	              };
	            }
	            while (true) {
	              var res = arr[i];
	              if (i in arr) {
	                i++;
	                return {
	                  done: false,
	                  value: res
	                };
	              } else i++;
	            }
	          }
	        }, symbols.iterator, function () {
	          return this;
	        });
	      }
	    }], [{
	      key: "isArray",
	      value: function isArray(val) {
	        return object.isArray(val);
	      }
	    }, {
	      key: "from",
	      value: function from(val, cb, self) {
	        if (symbols.iterator in val) {
	          var res = [];
	          var it = val[symbols.iterator]();
	          if (cb) {
	            for (var _val = it.next(); !_val.done; _val = it.next()) {
	              res[res.length] = func.invoke(cb, self, [_val.value]);
	            }
	          } else {
	            for (var _val2 = it.next(); !_val2.done; _val2 = it.next()) {
	              res[res.length] = _val2.value;
	            }
	          }
	          return res;
	        } else if ("length" in val) {
	          var _res2 = [];
	          if (cb) {
	            for (var i = 0; i < val.length; i++) {
	              if (i in val) _res2[i] = func.invoke(cb, self, [val[i]]);
	            }
	          } else {
	            for (var _i7 = 0; _i7 < val.length; _i7++) {
	              if (_i7 in val) _res2[_i7] = val[_i7];
	            }
	          }
	          return _res2;
	        } else if (val == null) throw new Error$1("Illegal argument");else return [];
	      }
	    }]);
	  }(symbols.iterator);
	  func.setCallable(Array, true);
	  func.setConstructable(Array, true);
	  return Array;
	}();

	var _symbols$iterator$1;
	var mapKey$1 = symbol.makeSymbol("Map.impl");
	_symbols$iterator$1 = symbols.iterator;
	var Map = /*#__PURE__*/function (_symbols$iterator2) {
	  function Map(iterable) {
	    _defineProperty(this, mapKey$1, undefined);
	    var _map = this[mapKey$1] = new map();
	    if (iterable != null) {
	      if (Array.isArray(iterable)) {
	        for (var i = 0; i < iterable.length; i++) {
	          if (!(i in iterable)) continue;
	          _map.set(iterable[i][0], iterable[i][1]);
	        }
	      } else {
	        var it = iterable[symbols.iterator]();
	        for (var val = it.next(); !val.done; val = it.next()) {
	          _map.set(val.value[0], val.value[1]);
	        }
	      }
	    }
	  }
	  return _createClass(Map, [{
	    key: "size",
	    get: function () {
	      return this[mapKey$1].size();
	    }
	  }, {
	    key: "get",
	    value: function get(key) {
	      return this[mapKey$1].get(key);
	    }
	  }, {
	    key: "has",
	    value: function has(key) {
	      return this[mapKey$1].has(key);
	    }
	  }, {
	    key: "set",
	    value: function set(key, val) {
	      this[mapKey$1].set(key, val);
	      return this;
	    }
	  }, {
	    key: "delete",
	    value: function _delete(key) {
	      if (!this[mapKey$1].has(key)) return false;else {
	        this[mapKey$1].delete(key);
	        return true;
	      }
	    }
	  }, {
	    key: "clear",
	    value: function clear() {
	      this[mapKey$1].clear();
	    }
	  }, {
	    key: "keys",
	    value: function keys() {
	      return this[mapKey$1].keys();
	    }
	  }, {
	    key: "values",
	    value: function values() {
	      var res = this[mapKey$1].keys();
	      for (var i = 0; i < res.length; i++) {
	        res[i] = this[mapKey$1].get(res[i]);
	      }
	      return res;
	    }
	  }, {
	    key: "entries",
	    value: function entries() {
	      var res = this[mapKey$1].keys();
	      for (var i = 0; i < res.length; i++) {
	        res[i] = [res[i], this[mapKey$1].get(res[i])];
	      }
	      return res;
	    }
	  }, {
	    key: "forEach",
	    value: function forEach(cb, self) {
	      var entries = this.entries();
	      for (var i = 0; i < entries.length; i++) {
	        func.invoke(cb, self, [entries[i][1], entries[i][0], this]);
	      }
	    }
	  }, {
	    key: _symbols$iterator2,
	    value: function () {
	      return func.invoke(Array.prototype[symbols.iterator], this.entries(), []);
	    }
	  }]);
	}(_symbols$iterator$1);
	var WeakMap = /*#__PURE__*/function () {
	  function WeakMap(iterable) {
	    _defineProperty(this, mapKey$1, undefined);
	    var _map = this[mapKey$1] = new map(true);
	    if (iterable != null) {
	      if (Array.isArray(iterable)) {
	        for (var i = 0; i < iterable.length; i++) {
	          if (!(i in iterable)) continue;
	          _map.set(iterable[i][0], iterable[i][1]);
	        }
	      } else {
	        var it = iterable[symbols.iterator]();
	        for (var val = it.next(); !val.done; val = it.next()) {
	          _map.set(val.value[0], val.value[1]);
	        }
	      }
	    }
	  }
	  return _createClass(WeakMap, [{
	    key: "get",
	    value: function get(key) {
	      return this[mapKey$1].get(key);
	    }
	  }, {
	    key: "has",
	    value: function has(key) {
	      return this[mapKey$1].has(key);
	    }
	  }, {
	    key: "set",
	    value: function set(key, val) {
	      this[mapKey$1].set(key, val);
	      return this;
	    }
	  }, {
	    key: "delete",
	    value: function _delete(key) {
	      if (!this[mapKey$1].has(key)) return false;else {
	        this[mapKey$1].delete(key);
	        return true;
	      }
	    }
	  }, {
	    key: "clear",
	    value: function clear() {
	      this[mapKey$1].clear();
	    }
	  }]);
	}();
	func.setCallable(Map, false);
	func.setCallable(WeakMap, false);

	var timeKey = symbol.makeSymbol("");
	var Date = function () {
	  var Date = /*#__PURE__*/function () {
	    function Date() {
	      _defineProperty(this, timeKey, undefined);
	    }
	    return _createClass(Date, null, [{
	      key: "now",
	      value: function now$1() {
	        return now();
	      }
	    }]);
	  }();
	  return Date;
	}();

	var Math = {};
	function method$2(name, func) {
	  object.defineField(Math, name, {
	    c: true,
	    e: false,
	    w: true,
	    v: func
	  });
	}
	method$2("max", function max() {
	  var res = -number.Infinity;
	  for (var i = 0; i < arguments.length; i++) {
	    if (res < arguments[i]) res = arguments[i];
	  }
	  return res;
	});
	method$2("min", function min() {
	  var res = +number.Infinity;
	  for (var i = 0; i < arguments.length; i++) {
	    if (res > arguments[i]) res = arguments[i];
	  }
	  return res;
	});
	method$2("abs", function abs(val) {
	  val = +val;
	  if (val < 0) return -val;else return val;
	});
	method$2("floor", function floor(val) {
	  val = val - 0;
	  if (number.isNaN(val)) return number.NaN;
	  var rem = val % 1;
	  if (rem < 0) rem += 1;
	  return val - rem;
	});
	method$2("ceil", function floor(val) {
	  val = val - 0;
	  if (number.isNaN(val)) return number.NaN;
	  var rem = val % 1;
	  if (rem === 0) return val;
	  if (rem < 0) rem += 1;
	  return val + (1 - rem);
	});
	method$2("pow", function pow(a, b) {
	  return number.pow(a, b);
	});
	method$2("log", function log(val) {
	  return number.log(val);
	});

	var _symbols$iterator;
	var mapKey = symbol.makeSymbol("Set.impl");
	_symbols$iterator = symbols.iterator;
	var Set = /*#__PURE__*/function (_symbols$iterator2) {
	  function Set(iterable) {
	    _defineProperty(this, mapKey, undefined);
	    var _map = this[mapKey] = new map();
	    if (iterable != null) {
	      if (Array.isArray(iterable)) {
	        for (var i = 0; i < iterable.length; i++) {
	          if (!(i in iterable)) continue;
	          _map.set(iterable[i], true);
	        }
	      } else {
	        var it = iterable[symbols.iterator]();
	        for (var val = it.next(); !val.done; val = it.next()) {
	          _map.set(val.value, true);
	        }
	      }
	    }
	  }
	  return _createClass(Set, [{
	    key: "size",
	    get: function () {
	      return this[mapKey].size();
	    }
	  }, {
	    key: "has",
	    value: function has(key) {
	      return this[mapKey].has(key);
	    }
	  }, {
	    key: "add",
	    value: function add(val) {
	      this[mapKey].set(val, true);
	      return this;
	    }
	  }, {
	    key: "delete",
	    value: function _delete(val) {
	      if (!this[mapKey].has(val)) return false;else {
	        this[mapKey].delete(val);
	        return true;
	      }
	    }
	  }, {
	    key: "clear",
	    value: function clear() {
	      this[mapKey].clear();
	    }
	  }, {
	    key: "keys",
	    value: function keys() {
	      return this[mapKey].keys();
	    }
	  }, {
	    key: "values",
	    value: function values() {
	      return this[mapKey].keys();
	    }
	  }, {
	    key: "entries",
	    value: function entries() {
	      var res = this[mapKey].keys();
	      for (var i = 0; i < res.length; i++) {
	        res[i] = [res[i], res[i]];
	      }
	      return res;
	    }
	  }, {
	    key: "forEach",
	    value: function forEach(cb, self) {
	      var vals = this.values();
	      for (var i = 0; i < vals.length; i++) {
	        func.invoke(cb, self, [vals[i], vals[i], this]);
	      }
	    }
	  }, {
	    key: _symbols$iterator2,
	    value: function () {
	      return func.invoke(Array.prototype[symbols.iterator], this.values(), []);
	    }
	  }]);
	}(_symbols$iterator);
	var WeakSet = /*#__PURE__*/function () {
	  function WeakSet(iterable) {
	    _defineProperty(this, mapKey, undefined);
	    var _map = this[mapKey] = new map(true);
	    if (iterable != null) {
	      if (Array.isArray(iterable)) {
	        for (var i = 0; i < iterable.length; i++) {
	          if (!(i in iterable)) continue;
	          _map.set(iterable[i], true);
	        }
	      } else {
	        var it = iterable[symbols.iterator]();
	        for (var val = it.next(); !val.done; val = it.next()) {
	          _map.set(val.value, true);
	        }
	      }
	    }
	  }
	  return _createClass(WeakSet, [{
	    key: "has",
	    value: function has(key) {
	      return this[mapKey].has(key);
	    }
	  }, {
	    key: "add",
	    value: function add(val) {
	      this[mapKey].set(val, true);
	      return this;
	    }
	  }, {
	    key: "delete",
	    value: function _delete(val) {
	      if (!this[mapKey].has(val)) return false;else {
	        this[mapKey].delete(val);
	        return true;
	      }
	    }
	  }, {
	    key: "clear",
	    value: function clear() {
	      this[mapKey].clear();
	    }
	  }]);
	}();
	func.setCallable(Set, false);
	func.setCallable(WeakSet, false);

	var JSON = {};
	function method$1(name, func) {
	  object.defineField(JSON, name, {
	    c: true,
	    e: false,
	    w: true,
	    v: func
	  });
	}
	method$1("parse", function parse(val) {
	  return json.parse(val);
	});
	method$1("stringify", function stringify(val) {
	  return json.stringify(val);
	});

	var console = {};
	function method(name, func) {
	  object.defineField(console, name, {
	    c: true,
	    e: false,
	    w: true,
	    v: func
	  });
	}
	method("log", function log() {
	  func.invoke(print, null, arguments);
	});

	function escaper(matcher) {
	  return function (text) {
	    var parts = [];
	    var i = 0;
	    while (true) {
	      var match = matcher.exec(text, i, false);
	      if (match == null) break;
	      var char = match.matches[0];
	      var code = string.toCharCode(char);
	      parts[parts.length] = string.substring(text, i, match.matches.index);
	      parts[parts.length] = "%" + code;
	      i = match.end;
	    }
	    parts[parts.length] = string.substring(text, i, text.length);
	    return string.stringBuild(parts);
	  };
	}
	var encodeURI = escaper(new regex("[^A-Za-z0-9\\-+.!~*'()]"));
	var encodeURIComponent = escaper(new regex("[^A-Za-z0-9\\-+.!~*'();/?:@&=+$,#]"));

	var PromiseState = /*#__PURE__*/function (PromiseState) {
	  PromiseState["Pending"] = "pend";
	  PromiseState["Fulfilled"] = "ful";
	  PromiseState["Rejected"] = "rej";
	  return PromiseState;
	}(PromiseState || {});
	var pState = symbol.makeSymbol("Promise.state");
	var pValue = symbol.makeSymbol("Promise.value");
	var pFulHandles = symbol.makeSymbol("Promise.fulfillHandles");
	var pRejHandles = symbol.makeSymbol("Promise.rejectHandles");
	function makePromise() {
	  return object.setPrototype(_defineProperty(_defineProperty(_defineProperty({}, pState, PromiseState.Pending), pFulHandles, []), pRejHandles, []), Promise$1.prototype);
	}
	function fulfill(self, val) {
	  if (self[pState] !== PromiseState.Pending) return;
	  if (self === val) throw new Error("A promise may not be fulfilled with itself");
	  if (val != null && typeof val.then === "function") {
	    val.then(function (val) {
	      return fulfill(self, val);
	    }, function (err) {
	      return _reject(self, err);
	    });
	  } else {
	    self[pValue] = val;
	    self[pState] = PromiseState.Fulfilled;
	    var handles = self[pFulHandles];
	    for (var i = 0; i < handles.length; i++) {
	      handles[i](val);
	    }
	    self[pFulHandles] = undefined;
	    self[pRejHandles] = undefined;
	  }
	}
	function _reject(self, val) {
	  if (self[pState] !== PromiseState.Pending) return;
	  if (self === val) throw new Error("A promise may not be rejected with itself");
	  if (val != null && typeof val.then === "function") {
	    val.then(function (val) {
	      return _reject(self, val);
	    }, function (err) {
	      return _reject(self, err);
	    });
	  } else {
	    self[pValue] = val;
	    self[pState] = PromiseState.Rejected;
	    var handles = self[pRejHandles];
	    for (var i = 0; i < handles.length; i++) {
	      handles[i](val);
	    }
	    self[pFulHandles] = undefined;
	    self[pRejHandles] = undefined;
	  }
	}
	function handle(self, ful, rej) {
	  if (self[pState] === PromiseState.Pending) {
	    if (ful != null) {
	      self[pFulHandles][self[pFulHandles].length] = ful;
	    }
	    if (rej != null) {
	      self[pRejHandles][self[pRejHandles].length] = rej;
	    }
	  } else if (self[pState] === PromiseState.Fulfilled) {
	    if (ful != null) ful(self[pValue]);
	  } else if (self[pState] === PromiseState.Rejected) {
	    if (rej != null) rej(self[pValue]);
	  }
	}
	var Promise$1 = /*#__PURE__*/function () {
	  function Promise(fn) {
	    var _this = this;
	    _defineProperty(this, pState, undefined);
	    _defineProperty(this, pValue, undefined);
	    _defineProperty(this, pFulHandles, []);
	    _defineProperty(this, pRejHandles, []);
	    this[pState] = PromiseState.Pending;
	    fn(function (val) {
	      return fulfill(_this, val);
	    }, function (err) {
	      return _reject(_this, err);
	    });
	  }
	  return _createClass(Promise, [{
	    key: "then",
	    value: function then(ful, rej) {
	      if (typeof ful !== "function") ful = undefined;
	      if (typeof rej !== "function") rej = undefined;
	      var promise = makePromise();
	      handle(this, function (val) {
	        return next(function () {
	          if (ful == null) fulfill(promise, val);else {
	            try {
	              fulfill(promise, ful(val));
	            } catch (e) {
	              _reject(promise, e);
	            }
	          }
	        });
	      }, function (err) {
	        return next(function () {
	          if (rej == null) _reject(promise, err);else {
	            try {
	              fulfill(promise, rej(err));
	            } catch (e) {
	              _reject(promise, e);
	            }
	          }
	        });
	      });
	      return promise;
	    }
	  }, {
	    key: "catch",
	    value: function _catch(rej) {
	      return this.then(undefined, rej);
	    }
	  }, {
	    key: "finally",
	    value: function _finally(fn) {
	      if (typeof fn !== "function") return this["then"]();
	      return this.then(function (v) {
	        fn();
	        return v;
	      }, function (v) {
	        fn();
	        throw v;
	      });
	    }
	  }], [{
	    key: "resolve",
	    value: function resolve(val) {
	      var res = makePromise();
	      fulfill(res, val);
	      return res;
	    }
	  }, {
	    key: "reject",
	    value: function reject(val) {
	      var res = makePromise();
	      _reject(res, val);
	      return res;
	    }
	  }]);
	}();
	func.setCallable(Promise$1, false);

	var abs = new map(true);
	var abKey = symbol.getSymbol("ArrayBuffer.impl");
	var ArrayBuffer = /*#__PURE__*/function () {
	  function ArrayBuffer(val) {
	    _defineProperty(this, abKey, undefined);
	    if (buffer.isBuff(val)) this[abKey] = val;else this[abKey] = buffer.buff(Number(val));
	  }
	  return _createClass(ArrayBuffer, [{
	    key: "byteLength",
	    get: function () {
	      return this[abKey].length;
	    }
	  }, {
	    key: "byteOffset",
	    get: function () {
	      return 0;
	    }
	  }]);
	}();
	function getAB(buff) {
	  var res = abs.get(buff);
	  if (res == null) {
	    res = new ArrayBuffer(buff);
	    abs.set(buff, res);
	  }
	  return res;
	}

	function _possibleConstructorReturn(_, res) {
	  return res;
	}

	var abstractIgnore = symbol.getSymbol("TypedArray.abstractIgnore");
	function typedArrayFuncs(perEl, constructor) {
	  return {
	    map: function (self, cb, fnSelf) {
	      var res = constructor(buffer.buff(self.length * perEl), 0, self.length);
	      for (var i = 0; i < self.length; i++) {
	        res[i] = func.invoke(cb, fnSelf, [self[i], i, self]);
	      }
	      return res;
	    },
	    filter: function (self, cb, fnSelf) {
	      var bigger = constructor(buffer.buff(self.length * perEl), 0, self.length);
	      var j = 0;
	      for (var i = 0; i < self.length; i++) {
	        if (func.invoke(cb, self, [self[i], i, fnSelf])) bigger[j++] = self[i];
	      }
	      var res = constructor(buffer.buff(j * perEl), 0, j);
	      for (var _i = 0; _i < j; _i++) res[_i] = bigger[_i];
	      return res;
	    },
	    slice: function (self) {
	      var start = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
	      var end = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : self.length;
	      start = wrapI(start, self.length);
	      end = wrapI(end, self.length);
	      if (end <= start) return constructor(buffer.buff(0), 0, 0);
	      var res = constructor(buffer.buff((end - start) * perEl), 0, end - start);
	      for (var i = 0; i < end - start; i++) {
	        res[i] = self[start + i];
	      }
	      return res;
	    },
	    subarray: function (self) {
	      var start = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
	      var end = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : self.length;
	      start = wrapI(start, self.length);
	      end = wrapI(end, self.length);
	      if (end <= start) return constructor(buffer.buff(0), 0, 0);
	      var offset = buffer.start(self);
	      return constructor(buffer.backer(self), offset + start, offset + end);
	    },
	    construct: function (self, start, end) {
	      if (typeof self === "number") {
	        return constructor(buffer.buff(self * perEl), 0, self);
	      }
	      if (self instanceof ArrayBuffer) {
	        var internal = self[abKey];
	        if (start === undefined) start = 0;
	        if (end === undefined) end = internal.length / perEl | 0;
	        return constructor(internal, start, end);
	      }
	      if (symbols.iterator in self && typeof self[symbols.iterator] === "function") {
	        var arr = [];
	        var i = 0;
	        var gen = self[symbols.iterator]();
	        for (var it = gen.next(); !it.done; it = gen.next()) {
	          arr[i++] = Number(it.value);
	        }
	        var _res = constructor(buffer.buff(i * perEl), 0, i);
	        for (var j = 0; j < i; j++) _res[j] = arr[j];
	        return _res;
	      }
	      var res = constructor(buffer.buff(self.length * perEl), 0, self.length);
	      for (var _i2 = 0; _i2 < self.length; _i2++) res[_i2] = self[_i2];
	      return res;
	    },
	    byteOffset: function (self) {
	      return buffer.start(self) * perEl;
	    },
	    byteLength: function (self) {
	      return (buffer.end(self) - buffer.start(self)) * perEl;
	    }
	  };
	}
	var TypedArray = /*#__PURE__*/function () {
	  function TypedArray(token) {
	    if (token !== abstractIgnore) {
	      throw new TypeError$1("TypedArray constructor can't be called");
	    }
	  }
	  return _createClass(TypedArray, [{
	    key: "buffer",
	    get: function () {
	      return getAB(buffer.backer(this));
	    }
	  }, {
	    key: "byteOffset",
	    get: function () {
	      throw new Error$1("abstract");
	    }
	  }, {
	    key: "byteLength",
	    get: function () {
	      throw new Error$1("abstract");
	    }
	  }, {
	    key: "forEach",
	    value: function forEach(cb, self) {
	      for (var i = 0; i < this.length; i++) {
	        if (i in this) func.invoke(cb, self, [this[i], i, this]);
	      }
	    }
	  }, {
	    key: "join",
	    value: function join() {
	      var delim = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : ",";
	      delim = String(delim);
	      var parts = [];
	      if (delim) {
	        for (var i = 0; i < this.length; i++) {
	          if (i) parts[parts.length] = delim;
	          parts[parts.length] = i in this ? String(this[i]) : "";
	        }
	      } else {
	        for (var _i3 = 0; _i3 < this.length; _i3++) {
	          parts[_i3] = _i3 in this ? String(this[_i3]) : "";
	        }
	      }
	      return string.stringBuild(parts);
	    }
	  }, {
	    key: "subarray",
	    value: function subarray() {
	      arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.length;
	      throw new Error$1("'slice' is an abstract method");
	    }
	  }, {
	    key: "slice",
	    value: function slice() {
	      arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.length;
	      throw new Error$1("'slice' is an abstract method");
	    }
	  }, {
	    key: "map",
	    value: function map(cb, self) {
	      throw new Error$1("'map' is an abstract method");
	    }
	  }, {
	    key: "filter",
	    value: function filter(cb, self) {
	      throw new Error$1("'filter' is an abstract method");
	    }
	  }, {
	    key: "reduce",
	    value: function reduce(cb, initial) {
	      var i = 0;
	      if (arguments.length <= 1) initial = this[i++];
	      for (; i < this.length; i++) {
	        initial = cb(initial, this[i], i, this);
	      }
	      return initial;
	    }
	  }, {
	    key: "some",
	    value: function some(cb, self) {
	      for (var i = 0; i < this.length; i++) {
	        if (func.invoke(cb, self, [this[i], i, this])) return true;
	      }
	      return false;
	    }
	  }, {
	    key: "every",
	    value: function every(cb, self) {
	      for (var i = 0; i < this.length; i++) {
	        if (!func.invoke(cb, self, [this[i], i, this])) return false;
	      }
	      return true;
	    }
	  }, {
	    key: "find",
	    value: function find(cb, self) {
	      for (var i = 0; i < this.length; i++) {
	        if (func.invoke(cb, self, [this[i], i, this])) return this[i];
	      }
	      return undefined;
	    }
	  }, {
	    key: "indexOf",
	    value: function indexOf(val) {
	      var start = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
	      start |= 0;
	      if (start < 0) start = 0;
	      for (var i = start; i < this.length; i++) {
	        if (this[i] === val) return i;
	      }
	      return -1;
	    }
	  }, {
	    key: "lastIndexOf",
	    value: function lastIndexOf(val) {
	      var start = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
	      start |= 0;
	      if (start < 0) start = 0;
	      for (var i = this.length - 1; i >= start; i--) {
	        if (this[i] === val) return i;
	      }
	      return -1;
	    }
	  }, {
	    key: "includes",
	    value: function includes(val) {
	      for (var i = 0; i < this.length; i++) {
	        if (this[i] === val) return i;
	      }
	      return false;
	    }
	  }, {
	    key: "sort",
	    value: function sort(cb) {
	      cb || (cb = function (a, b) {
	        return a - b;
	      });
	      return object.sort(this, cb);
	    }
	  }, {
	    key: "reverse",
	    value: function reverse() {
	      var mid = this.length >> 1;
	      var end = this.length - 1;
	      for (var i = 0; i < mid; i++) {
	        var tmp = this[i];
	        this[i] = this[end - i];
	        this[end - i] = tmp;
	      }
	      return this;
	    }
	  }]);
	}();

	var factory$1 = buffer.uint8;
	var funcs$1 = typedArrayFuncs(1, factory$1);
	var Uint8Array = /*#__PURE__*/function (_TypedArray) {
	  function Uint8Array(obj, start, end) {
	    var _this;
	    _this = _callSuper(this, Uint8Array, [abstractIgnore]);
	    return _possibleConstructorReturn(_this, funcs$1.construct(obj, start, end));
	  }
	  _inherits(Uint8Array, _TypedArray);
	  return _createClass(Uint8Array, [{
	    key: "byteOffset",
	    get: function () {
	      return funcs$1.byteOffset(this);
	    }
	  }, {
	    key: "byteLength",
	    get: function () {
	      return funcs$1.byteLength(this);
	    }
	  }, {
	    key: "subarray",
	    value: function subarray(start, end) {
	      return funcs$1.subarray(this, start, end);
	    }
	  }, {
	    key: "slice",
	    value: function slice(start, end) {
	      return funcs$1.slice(this, start, end);
	    }
	  }, {
	    key: "map",
	    value: function map(cb, self) {
	      return funcs$1.map(this, cb, self);
	    }
	  }, {
	    key: "filter",
	    value: function filter(cb, self) {
	      return funcs$1.filter(this, cb, self);
	    }
	  }]);
	}(TypedArray);

	var factory = buffer.int32;
	var funcs = typedArrayFuncs(4, factory);
	var Int32Array = /*#__PURE__*/function (_TypedArray) {
	  function Int32Array(obj, start, end) {
	    var _this;
	    _this = _callSuper(this, Int32Array, [abstractIgnore]);
	    return _possibleConstructorReturn(_this, funcs.construct(obj, start, end));
	  }
	  _inherits(Int32Array, _TypedArray);
	  return _createClass(Int32Array, [{
	    key: "subarray",
	    value: function subarray(start, end) {
	      return funcs.subarray(this, start, end);
	    }
	  }, {
	    key: "slice",
	    value: function slice(start, end) {
	      return funcs.slice(this, start, end);
	    }
	  }, {
	    key: "map",
	    value: function map(cb, self) {
	      return funcs.map(this, cb, self);
	    }
	  }, {
	    key: "filter",
	    value: function filter(cb, self) {
	      return funcs.filter(this, cb, self);
	    }
	  }]);
	}(TypedArray);

	function fixup(clazz) {
	  object.setPrototype(clazz, Function.prototype);
	  object.setPrototype(clazz.prototype, Object$1.prototype);
	  return clazz;
	}
	object.setPrototype(target, Object$1.prototype);
	object.defineField(target, "undefined", {
	  e: false,
	  c: false,
	  w: false,
	  v: undefined
	});
	target.Symbol = fixup(Symbol);
	target.Number = fixup(Number$1);
	target.String = fixup(String$1);
	target.Boolean = fixup(Boolean);
	target.Object = Object$1;
	target.Function = fixup(Function);
	target.Array = fixup(Array);
	target.Error = fixup(Error$1);
	target.RangeError = RangeError;
	target.SyntaxError = SyntaxError;
	target.TypeError = TypeError$1;
	fixup(TypedArray);
	target.ArrayBuffer = fixup(ArrayBuffer);
	target.Uint8Array = Uint8Array;
	target.Int32Array = Int32Array;
	target.Map = fixup(Map);
	target.WeakMap = fixup(WeakMap);
	target.Set = fixup(Set);
	target.WeakSet = fixup(WeakSet);
	target.RegExp = fixup(RegExp);
	target.Date = fixup(Date);
	target.Promise = fixup(Promise$1);
	target.Math = object.setPrototype(Math, Object$1.prototype);
	target.JSON = object.setPrototype(JSON, Object$1.prototype);
	target.console = object.setPrototype(console, Object$1.prototype);
	target.parseInt = Number$1.parseInt;
	target.parseFloat = Number$1.parseFloat;
	target.NaN = Number$1.NaN;
	target.Infinity = Number$1.POSITIVE_INFINITY;
	target.encodeURI = encodeURI;
	target.encodeURIComponent = encodeURIComponent;
	setGlobalPrototypes({
	  string: String$1.prototype,
	  number: Number$1.prototype,
	  boolean: Boolean.prototype,
	  symbol: Symbol.prototype,
	  object: Object$1.prototype,
	  array: Array.prototype,
	  function: Function.prototype,
	  error: Error$1.prototype,
	  syntax: SyntaxError.prototype,
	  range: RangeError.prototype,
	  type: TypeError$1.prototype,
	  uint8: Uint8Array.prototype,
	  int32: Int32Array.prototype,
	  regex: RegExp
	});

})();
//# sourceMappingURL=index.js.map
